---
layout: cp
title: "ErCiccione: Coordinator of the Localization Workgroup - March"
author: ErCiccione
date: 31 March 2019
amount: 144
milestones:
  - name: April
    funds: 33% (48 XMR)
    done: 7 April 2019
    status: finished
  - name: May
    funds: 33% (48 XMR)
    done: 7 May 2019
    status: finished
  - name: June
    funds: 33% (48 XMR)
    done: 7 June 2019
    status: finished
payouts:
  - date: 14 June 2019
    amount: 144
---


Hi, This is ErCiccione with a new proposal for another quarter. You can see my last proposal [here](https://forum.getmonero.org/9/work-in-progress/91261/erciccione-coordinator-of-the-localization-workgroup).

# Who

Thanks to the generosiy of the community, i've been able to coordinate the localization workgroup for more than a year now. The localization workgroup is responsable for keeping our wallets/software/documentation/website multilingual, with the goal of reaching as many people as possible.

I've been a Monero contributors for a couple of years now, and in this time i put my hands on basically all Monero projects. I like to be everywhere and at the moment, beside the localization workgroup, some of my major contributions include:

- Help with the maintainance of getmonero.org and the monero-gui repository
- I founded and maintain the [Monero Ecosystem Project](https://github.com/monero-ecosystem/meta)
- I created and maintain the official [guide for the GUI wallet](https://github.com/monero-ecosystem/monero-GUI-guide)
- I do some [scam hunting](https://www.reddit.com/r/Monero/comments/asqrbu/church_of_monero_enough_is_enough_how_the_leader/) sometimes, but that's for fun :)


# What

All goals from past FFS were achieved, except for moving Monerujo to Pootle. **The emergency hard fork forced me to change many plans**, and i found myself with few days and a lot of languages to work on, for the GUI. This situation was a big stress test for Pootle, and i'm happy to say it passed it. **We managed to translate and review 2/3 of the languages of the gui** (the total is more than 30 languages) **in about 48 hours**. Thousands of strings translated and reviewed and about 60 volunteers partecipated. That was an amazing response and i'm very proud of it, sure i aged faster than i should have in those days, but it worthed it :)
&nbsp;

## What do i practically do?

My job consists in making Monero as multilingual as possible, so that we can reach as many people as possible. What i do can be divided in two categories: *Support* and *coordination*.

For **support**, i mean that every single aspiring contributor is followed by me from the moment they make known their intention to help with translation until the moment they delivery it. This means find anspiring contributors on the many platforms we are on, teach them how to use our tools, answer any question and guide the contributor step-by-step. This is the most time consuming part of the work, since most of the contributors have no technical knowledge (which is the reason why we adopted [Pootle](https://translate.getmonero.org/projects/)).

**Coordinate** the workgroup means maintain the tools we use, review translations, make sure translations are up to date and make sure to always improve the way multi-language communities are reached, make announcements and call for translators. It also means resolve consensus disputes when they come up and help translators to work together to have as result an high quality work. I also try to always find new ways to make the work easier for the translator.

It's very hard to give some deliverable goals in my CCS proposals, but i can tell you that in the next three months i will keep pushing on using Pootle as the main platform for translators, this will be achieved moving all compatible projects on the platform (we already have CLI and GUI, Monerujo next), adopt a Translation Memory for consistency across projects, language-specific teams. I will also completely rethink the way we use Taiga, the task tracker, to make it easier to use and more interactive for everybody.


## Projects i take care of

As coordinator of the Localization Workgroup, **I'm the point of contact for Monero developers and users about the translations of all our software/wallets/documentation**. I am the one who assure new translations get added, old ones are updated and our guides are always available and up to date.
In practice i take care of:

+ Monero GUI Wallet
+ Monero CLI wallet
+ Monerujo
+ Monero website (getmonero.org)
+ [Monero Outreach Workgroup](https://github.com/monero-ecosystem/outreach-docs) (documentation)
+ Guide of the GUI wallet
+ Other small projects (the complete list can be found in the [Backlog on Taiga](https://taiga.getmonero.org/project/erciccione-monero-localization/backlog))

**About Kovri**. Kovri has been in this list for long time, but after all the drama from some months ago, i didn't hear anything from Anonimal and the project appear dead at the moment. I'm not wasting more resources on what appear to be a dead project.

# Links with info about me and the localization workgroup:

- [monero-translations](https://github.com/monero-ecosystem/monero-translations) on GitHub
- [My profile on Gitlab](https://repo.getmonero.org/erciccione)
- [My profile on GitHub](https://github.com/erciccione)
- [Taiga](https://taiga.getmonero.org/project/erciccione-monero-localization)

Updates about the localization workgroup are given every community meeting (twice a months), but i often make announcements on reddit (/u/erciccione) and Twitter (@calicferciccio).

# Milestones

Same as always: the rate i ask is $20/hour 30 hours/week (but i'm usually available for much longer than that), for 3 months. This means, considering an average of 1 XMR = 50$, 48 XMR each month, for a total of 144 XMR. Payouts will be around the 7th of every month (April, May, June). I'm making this proposal a bit late, so i'm asking the funds for the work i've done since the end of last proposal. Feedbacks, suggestions, questions and critics are welcome.

