---
layout: wip
title: Monero Garden
author: anhdres
date: September 30, 2022
amount: 71
milestones:
  - name: Texts and structure done
    funds: 30
    done:
    status: unfinished
  - name: Illustrations and animations done
    funds: 30
    done:
    status: unfinished
  - name: Website up
    funds: 11
    done:
    status: unfinished
payouts:
  - date:
    amount:
  - date:
    amount:
  - date:
    amount:
---

# Monero Garden

## The idea

The Monero Garden would initially be a website available at [monero.garden](https://anhdr.es), that worked as a clean and friendly space to start someone's Monero journey. Is a resource I wished many times existed when I told someone about Monero. The naming has two reasons: it acts as a Monero kindergarten of sorts, the starting point of your education, where you learn without any dread; but also as a real garden, with paths you can graciously take and effortlessly stroll at your own pace while discovering new things on the way.

Its language, both visual and writing, should be approachable for a 11 year old and above. Trying my best to keep it clean of technical wording, yet making it engaging for an adult as well. It's a difficult balance but I think it's worth pursuit it.

I want to try a different approach to the rest of Monero content I've seen so far, kind of a Choose Your Own Adventure book, where the questions that pop inside the reader's head guide the consumption of the material, and not presenting (if possible) information that wasn't felt the need for. The aim is *relevancy*, which should maximize retention and engagement.

I believe that the pre-adolescents are specially important to talk to. They are starting their financial life earlier and earlier, the boundaries of *real money* and *virtual money* are going to be as dilluted as ever, so if they find Monero soon enough, they could be a strong agent of change and help avoid the dystopian version of that merge. Believe it or not, we (I'm older than 40 now) are not the future anymore. Luckily we're still the present, so there's a lot we can do!

## Layout

Overall, it's design should mimic children picture books. Their design is not accidental. They display images and succinct text on almost every page, which don't work in a redundant way, but complement each other. Clean, minimal background and bold, colorful illustrations. A consistent character design and color palette. If needed to reinforce a concept, the illustrations could be short animations.

At the start page, the visitor would be faced with three choices. In my interactions with newcomers, those three I've noticed are the main starting points of everyone's Monero path:

- How to use Monero.

- Why to use Monero.

- How Monero works.

Each choice would take the visitor to a different path, of increasing length. According to my notes, *how to use it* is the shortest and *how it works* the longest. The way I envision it, besides navigation and a general menu, each page would have four elements:

- The illustration

- The short, bold statement.

- A longer, yet brief explanation of the statement above.

- An option to expand the topic if interested, like footnotes or links to outside sources to explore.

## Scope

To me, making it a website is the most effective initial form. It's big and clean, and can be accessed almost everywhere. For obvious reasons to this community, it should also be accesible via Tor and i2p. **So a working, fully functional website with those three content branches is the scope of this proposal.**

The nature of the idea makes it very versatile to use as basis for a book in both physical and electronic forms, a series of animated, narrated videos, or even an app. These formats are outside of the scope of this proposal but if the material is good enough to engage people I think all those mediums would have their merits.

The initial material would be in English, but obviously I see the appeal of having it translated in as many languages as possible, since it's particularly targeted towards newcomers.

## Rights

I plan to release this material with either a [Creative Commons BY-NC-SA  license](https://creativecommons.org/licenses/by-nc-sa/4.0/) that allows anyone to obviously access it for free (it's a website) but also create derivative works, translate it, or distribute it freely, as long as credit is mantained and it's not exploited commercially.

## Budget

Based on my experience, I think this first stage will take roughly 3 months. I plan to allocate 4 hrs per day to this project. At an hourly rate of 40 USD, that's 4 hrs x 60 working days = 9600 USD.

I'd also need help with the technical aspects of setting up the server and different access. For what I could gather, it would take a 20 hours of work, which at the same rate of 40 USD/h amounts to 800 USD.

At the current XMR price of 145 USD/XMR, it would be 71 XMR.

I plan to pay domain, hosting, and other small expenses out of that budget. If the traffic were so big it demanded a considerable investment, I'd consider either open a new request for funds, or looking into other possible solutions that wouldn't cause any extra cost for the community.

## Relevant information about me

I've worked as creative director, illustrator, copywriter, and animator for the past 15 years. You can take a look at some of my commercial work at [Sloop Studio](https://www.sloopstudio.tv/).

In the Monero world, I've been in the community since 2017, since then I've worked alongside with @m2049r and @Baltsar in [Monerujo](https://www.monerujo.io/), doing content, communications, support, and UX. One example would be [the articles explaining features or concepts behind Monero.](https://anhdres.medium.com/)

I've worked alongside @serhack in both [Mastering Monero](https://masteringmonero.com/) and [serhack.me](https://serhack.me/), doing all the illustrations.

Worked with @rehrar on designs for [Cypher Market](https://www.cyphermarket.com/) and [Cypher Stack](https://cypherstack.com/). Also materials for @msvblab's [Monero Devices](https://shop.monerodevices.com/). As well as designs for several Monero-related projects and individuals.

Hosted the short lived [El Monero](https://www.youtube.com/channel/UCNvrbeVzrszpN7vQnMoCTVA/videos) podcast together with @rottenwheel, and gave out a few [public](https://youtu.be/s8RPE5AIB-A) [talks](https://youtu.be/78zcD7yWQ0E) and [interviews](https://youtu.be/Cx7XkZxXOKM) introducing Monero to the Spanish-speaking public.

On a related note, I've made the illustrations for the newest [Tails](https://tails.net) redesign and I keep working closely on their support materials.

That's pretty much all I can think of right now, be sure to ask away!
